﻿using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace Gbjam5MksGame
{
    class BackgroundPlateGameVisual : GameVisual
    {
        public bool DoBlankScreen = false;

        Vector2 screenPos = new Vector2(0.0f, 0.0f);

        public BackgroundPlateGameVisual(Game game) : base(game)
        {
        }

        public override void Update(GameTime gameTime)
        {
            base.Update(gameTime);
        }

        public override void Draw(GameTime gameTime)
        {
            base.Draw(gameTime);

            myGame.GraphicsDevice.SetRenderTarget(myGame.BackgroundRenderTarget);

            myGame.SpriteBatch.Begin(SpriteSortMode.Deferred, BlendState.AlphaBlend, SamplerState.PointClamp, DepthStencilState.Default, RasterizerState.CullNone);

            if (DoBlankScreen)
            {
                myGame.SpriteBatch.Draw(myGame.BlankScreenTexture, screenPos, Color.White);
            }
            else
            {
                switch (myGame.CurrentGameMode)
                {
                    case GameMode.Title:
                        myGame.SpriteBatch.Draw(myGame.TitleScreenTexture, screenPos, Color.White);
                        break;
                    case GameMode.Configure:
                        myGame.SpriteBatch.Draw(myGame.ConfigureScreenTexture, screenPos, Color.White);
                        break;
                    case GameMode.GameOver:
                        myGame.SpriteBatch.Draw(myGame.GameOverScreenTexture, screenPos, Color.White);
                        break;
                    case GameMode.GameWin:
                        myGame.SpriteBatch.Draw(myGame.GameWinScreenTexture, screenPos, Color.White);
                        break;
                    case GameMode.Help:
                        myGame.SpriteBatch.Draw(myGame.HelpScreenTexture, screenPos, Color.White);
                        break;
                    case GameMode.Ingame:
                        myGame.SpriteBatch.Draw(myGame.IngameScreenTexture, screenPos, Color.White);
                        break;
                    default:
                        break;
                }
            }

            myGame.SpriteBatch.End();
        }
    }
}

