﻿using Microsoft.Xna.Framework;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Gbjam5MksGame
{
    public class MediumExplosion : AnimatedMapItem
    {
        public MediumExplosion()
        {
        }

        public override void PrepareItem(MyGame game)
        {
            base.PrepareItem(game);

            AutoFrameAdvance = true;
            IsPlaying = true;
            StopOnPlayComplete = true;
            FrameIndex = 0;
            NosFrames = 8;
            FrameHold = 2;

            MapItems = new MapTileItem[NosFrames];
            for(int index = 0; index < NosFrames; index++)
            {
                MapItems[index] = new MapTileItem();

                MapItems[index].Type = MapItemType.Explosion;

                MapItems[index].Position = new Vector2(0.0f, 0.0f);
                MapItems[index].Height = 0.0f;
                MapItems[index].PixelSize = new int[2] { 16, 16 };
                MapItems[index].State = MapItemState.None;
                MapItems[index].HitPoints = 1;

                MapItems[index].Sprite = new SpriteGameVisual(myGame);
                MapItems[index].Sprite.DrawOrder = (int)DisplayLayer.MapLayer4Sprites;
                MapItems[index].Sprite.Enabled = false;
                MapItems[index].Sprite.UpdateOrder = (int)UpdateLayer.Last;
                MapItems[index].Sprite.SourceImage = myGame.TilesTexture;
                MapItems[index].Sprite.SourceRectangle = new Rectangle(index * 16, 176, 16, 16);
                MapItems[index].Sprite.TargetPosition = new Vector2(0.0f, 0.0f);
                MapItems[index].Sprite.TargetSize = new Vector2(16.0f, 16.0f);
                MapItems[index].Sprite.Visible = true;
            }

            AddAllSpritesToComponents();
        }

        protected override void AddAllSpritesToComponents()
        {
            if (MapItems == null)
            {
                return;
            }

            foreach (MapTileItem mapItem in MapItems)
            {
                if (mapItem != null && mapItem.Sprite != null)
                {
                    myGame.Components.Add(mapItem.Sprite);
                }
            }
        }

        protected override void RemoveAllSpritesFromComponents()
        {
            if (MapItems == null)
            {
                return;
            }

            foreach (MapTileItem mapItem in MapItems)
            {
                if (mapItem != null && mapItem.Sprite != null)
                {
                    myGame.Components.Remove(mapItem.Sprite);
                }
            }
        }
    }
}
