﻿using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace Gbjam5MksGame
{
    public class SpriteGameVisual : GameVisual
    {
        public Texture2D SourceImage;
        public Rectangle SourceRectangle;
        public Vector2 TargetPosition;
        public Vector2 TargetSize;

        public SpriteGameVisual(Game game) : base(game)
        {
        }

        public override void Update(GameTime gameTime)
        {
            base.Update(gameTime);
        }

        public override void Draw(GameTime gameTime)
        {
            base.Draw(gameTime);

            Rectangle targetRectangle = new Rectangle((int)TargetPosition.X, (int)TargetPosition.Y, (int)TargetSize.X, (int)TargetSize.Y);

            myGame.GraphicsDevice.SetRenderTarget(myGame.BackgroundRenderTarget);

            myGame.SpriteBatch.Begin(SpriteSortMode.Deferred, BlendState.AlphaBlend, SamplerState.PointClamp, DepthStencilState.Default, RasterizerState.CullNone);

            myGame.SpriteBatch.Draw(SourceImage, targetRectangle, SourceRectangle, Color.White);

            myGame.SpriteBatch.End();
        }
    }
}
